#
#       HBS REDUCTION SUB ROUTINE
#
#       Making Kappa image : hbsupsum3.cl
#
#       1997/09/08      K.Kawabata Ver.1.00
#       1998/06/28      K.Kawabata Ver.1.10
#
#

procedure hbsupsum3

begin

  file infn1, infn2, outfn
  int i, c
  int n_up = -1
  file fn_nposhwp = "HBS.nposhwp"
  string buf=""


#----- read number of position angle of half-wave plate

  if( access( fn_nposhwp ) == 1 )
  {
    list = fn_nposhwp
    if( fscan( list, n_up ) != 1 )
    {
      printf( "Warning: cannot read '%s'\n", fn_nposhwp )
    }
  }
  if( n_up < 0 )
  {
    printf( "Input sequencial number of PA of hwp (1-16) >> " )
    c = scan( buf )
    while( int( buf ) < 1 || int( buf ) > 16 )
      c = scan( buf )
    n_up = int( buf )

    if( access( fn_nposhwp ) == 1 )
      delete( fn_nposhwp, ver- )
    printf( "%2d\n", n_up, > fn_nposhwp )
  }

#----- main routine

  for( i=0; i<=(n_up-1); i+=1 )
  {

#----- upper hole

   # 2HL
    infn1 = envget( "_up2hlu" )//i//".e"
    infn2 = envget( "_up2hlu" )//i//".o"
    outfn = envget( "_up2hlu" )//i
    if( access( infn1//".imh" ) == 1 && access( infn2//".imh" ) == 1 )
    {
      printf( "%s ", outfn )
      if( access( outfn//".imh" ) == 1 )
        imdelete( outfn, ver- )
      imarith( infn1, "/", infn2, outfn, title="Kappa image",\
               pixtype="real", calctype="real", divzero=1.,\
	       hparams="EXPTIME", ver- )
    }

   # 2S2
    infn1 = envget( "_up2s2u" )//i//".e"
    infn2 = envget( "_up2s2u" )//i//".o"
    outfn = envget( "_up2s2u" )//i
    if( access( infn1//".imh" ) == 1 && access( infn2//".imh" ) == 1 )
    {
      printf( "%s ", outfn )
      if( access( outfn//".imh" ) == 1 )
        imdelete( outfn, ver- )
      imarith( infn1, "/", infn2, outfn, title="Kappa image",\
               pixtype="real", calctype="real", divzero=1.,\
	       hparams="EXPTIME", ver- )
    }

#----- lower hole

   # 2HL
    infn1 = envget( "_up2hll" )//i//".e"
    infn2 = envget( "_up2hll" )//i//".o"
    outfn = envget( "_up2hll" )//i
    if( access( infn1//".imh" ) == 1 && access( infn2//".imh" ) == 1 )
    {
      printf( "%s ", outfn )
      if( access( outfn//".imh" ) == 1 )
        imdelete( outfn, ver- )
      imarith( infn1, "/", infn2, outfn, title="Kappa image",\
               pixtype="real", calctype="real", divzero=1.,\
	       hparams="EXPTIME", ver- )
    }

   # 2S2
    infn1 = envget( "_up2s2l" )//i//".e"
    infn2 = envget( "_up2s2l" )//i//".o"
    outfn = envget( "_up2s2l" )//i
    if( access( infn1//".imh" ) == 1 && access( infn2//".imh" ) == 1 )
    {
      printf( "%s ", outfn )
      if( access( outfn//".imh" ) == 1 )
        imdelete( outfn, ver- )
      imarith( infn1, "/", infn2, outfn, title="Kappa Image",\
               pixtype="real", calctype="real", divzero=1.,\
	       hparams="EXPTIME", ver- )
    }
    printf( "\n" )
  }

end

